"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getDocDTO = void 0;
const index_1 = require("../../../../index");
const getDocDTO = (classDTO) => {
    const fields = (0, index_1.getMetadataDTO)().getFieldDTO(classDTO);
    const result = {};
    const required = [];
    fields.forEach((field) => {
        var _a, _b, _c, _d, _e, _f, _g, _h;
        let type = [String, Number, Boolean].includes(field.type)
            ? field.type.name.toLocaleLowerCase()
            : [index_1.ObjectId, Date].includes(field.type)
                ? "string"
                : [Array].includes(field.type)
                    ? "array"
                    : "object";
        if (type === "object" && field.isEnum) {
            type = "string";
        }
        result[field.name] = {
            type: type,
            enum: field.isEnum && type !== "array" ? Object.values((_a = field.vectorProps) === null || _a === void 0 ? void 0 : _a.elementDataType) : undefined,
            description: field.description,
        };
        if (field.isRequire) {
            required.push(field.name);
        }
        if (type == "object") {
            const docDTO = (0, exports.getDocDTO)(field.type);
            result[field.name]["properties"] = docDTO.result;
            result[field.name]["required"] = docDTO.required;
        }
        // if type is array then assign items
        if (type == "array") {
            if (((_b = field === null || field === void 0 ? void 0 : field.vectorProps) === null || _b === void 0 ? void 0 : _b.elementDataType) &&
                [index_1.DataType.BOOLEAN, index_1.DataType.NUMBER, index_1.DataType.STRING].includes((_c = field === null || field === void 0 ? void 0 : field.vectorProps) === null || _c === void 0 ? void 0 : _c.elementDataType)) {
                result[field.name].items = {
                    type: field.isEnum ? "string" : ((_d = field === null || field === void 0 ? void 0 : field.vectorProps) === null || _d === void 0 ? void 0 : _d.elementDataType).toLocaleLowerCase(),
                    enum: field.isEnum ? Object.values((_e = field.vectorProps) === null || _e === void 0 ? void 0 : _e.elementDataType) : undefined
                };
            }
            else {
                const docDTO = (0, exports.getDocDTO)((_f = field === null || field === void 0 ? void 0 : field.vectorProps) === null || _f === void 0 ? void 0 : _f.elementDataType);
                result[field.name].items = {
                    type: ((_g = field === null || field === void 0 ? void 0 : field.vectorProps) === null || _g === void 0 ? void 0 : _g.elementDataType) && !field.isEnum ? "object" : "string",
                    properties: docDTO.result,
                    required: docDTO.required,
                    enum: field.isEnum ? Object.values((_h = field.vectorProps) === null || _h === void 0 ? void 0 : _h.elementDataType) : undefined
                };
            }
        }
    });
    return { result, required };
};
exports.getDocDTO = getDocDTO;
