import { QueryBuilder } from "../queryBuilder";
import { IPagination } from "../global/interface";
import { IIdentifiable } from "../models/interfaces/IIdentifiable";
import { ResponseBuilder } from "../responseBuilder";
import { Request } from "../global/types/express";
import { ExpandItemFilterString } from "./interfaces/IQueryCRUD";
import { WithRelation } from "../queryBuilder/interfaces/WithRelation";
import { AbstractHttpController } from "./AbstractHttpController";
export declare class CRUDController<T extends IIdentifiable> extends AbstractHttpController {
    readonly queryBuilder: QueryBuilder<T>;
    constructor(queryBuilder: QueryBuilder<T>);
    getQueries(req: Request, queriesString: string): import("../queryBuilder/interfaces/QueryCondition").QueryCondition<T>;
    getPagination(req: Request): IPagination;
    getWith(req: Request, _with: any[], queryBuilder?: QueryBuilder<any>, deep?: number): any[];
    getOperatorFilter(req: Request, operatorFilter: string, queryBuilder?: QueryBuilder<any>): import("../queryBuilder/interfaces/QueryCondition").QueryCondition<any>;
    getOperatorWith(req: Request, _with: ExpandItemFilterString[], queryBuilder?: QueryBuilder<any>, deep?: number): WithRelation<any, any>[];
    get(req: Request): Promise<{
        data: T[];
        totalCount: number;
    }>;
    create(req: Request): Promise<{
        data: T;
    }>;
    update(req: Request): Promise<{
        data: T[];
    }>;
    delete(req: Request): Promise<ResponseBuilder<import("mongodb").DeleteResult>>;
}
