"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Column = exports.Model = void 0;
const di_1 = require("../di");
const metadata_1 = require("../global/metadata");
function Model() {
    return (constructorFn) => {
        (0, di_1.getServiceProvider)().register(constructorFn);
        (0, metadata_1.getMetadataTable)().getModelTable(constructorFn);
        (0, di_1.getServiceProvider)().register(constructorFn, di_1.InjectionMode.SINGLETON, constructorFn.name);
    };
}
exports.Model = Model;
function Column(description, options) {
    return function (object, name) {
        const type = Reflect.getMetadata("design:type", object, name);
        (0, metadata_1.getMetadataTable)().getModelTable(object.constructor);
        (0, metadata_1.getMetadataTable)().pushColumn(object.constructor, Object.assign({ name,
            type,
            description }, options));
    };
}
exports.Column = Column;
