"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.pickDataDTO = void 0;
const mongodb_1 = require("mongodb");
const metadata_1 = require("../global/metadata");
function pickDataDTO(data, dto) {
    const fields = (0, metadata_1.getMetadataDTO)().getFieldDTO(dto);
    let result = {};
    fields.forEach((field) => {
        if (data[field.name] !== undefined) {
            switch (field.type) {
                case String:
                case Number:
                case Boolean:
                case Date:
                case mongodb_1.ObjectId:
                    Object.assign(result, { [field.name]: data[field.name] });
                    break;
                case Array:
                    Object.assign(result, { [field.name]: pickDataArrayDTO(data[field.name], field.type) });
                    break;
                default:
                    // field.type is class
                    if (data[field.name] !== null) {
                        Object.assign(result, { [field.name]: pickDataDTO(data[field.name], field.type) });
                    }
                    else {
                        Object.assign(result, { [field.name]: data[field.name] });
                    }
                    break;
            }
        }
    });
    return result;
}
exports.pickDataDTO = pickDataDTO;
function pickDataArrayDTO(data, dto) {
    return data.map(e => pickDataDTO(e, dto));
}
