"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MetadataRelation = void 0;
const errorBuilder_1 = require("../errorBuilder");
const string_1 = require("../helpers/string");
class MetadataRelation {
    constructor() {
        this.data = [];
    }
    pushRelationship(params) {
        this.data.push(params);
    }
    getAll() {
        return this.data;
    }
    getReference(refs) {
        const nameFilter = (0, string_1.sortWordAlphabets)([refs.modelChild().name, refs.modelParent().name]);
        const ref = this.data.find(e => (0, string_1.sortWordAlphabets)([e.refs.modelParent().name, e.refs.modelChild().name]) == nameFilter);
        if (!ref) {
            throw errorBuilder_1.ErrorBuilder.notFound("Reference not found");
        }
        return ref;
    }
}
exports.MetadataRelation = MetadataRelation;
